 
CON

        _clkmode        = xtal1 + pll16x
        _xinfreq        = 5_000_000
        x_pin           = 6
        us              =80_000_000/1000000
        SHT_DATA      = 5                                     ' SHT-11 data pin
        SHT_CLOCK     = 4                                    ' SHT-11 clock pin
VAR

        long    testerror

        long    vlong
        word    vword
        byte    vbyte
        long    xG,yG,levelx
OBJ

        term    : "tv_text"
        timer   : "Timer"
        sht     : "Sensirion"
        fp      : "FloatString"
        f       : "Float32"   
PUB start | i,xgTot,aveXg,maxXg,minXG,mph,runcor,ii,elapsedtix,iii,iiii,temptix,xGAccel,shttemp,rawtemp
  timer.start
  sht.start(SHT_DATA, SHT_CLOCK)                        ' start sensirion object

  levelx:=0
  xG:=0
  mph:=0
  runcor:=0
  minXG:=10_000_000
  term.start(12)
  xgTot:=0

  waitcnt(clkfreq/10 + cnt)
  calibratex(x_pin)
  repeat 20
    xg:= readGforce(x_pin)
    xgtot:=xgtot+xg
  avexg:=xgtot/20

  xgTot:=0
  i:=0
  maxXg:=-100000000
  minXg:= 100000000
  I:=0
  temptix:=0
  timer.run

  repeat 

    term.out(13)
    term.str(string("xG =") )

    term.dec(xg)
    term.str(string("   ") )

    term.out(13)
    term.str(string("levelx =") )

    term.dec(levelx)
    term.str(string("   ") )

    term.out(13)
    term.str(string("Raw Temp: "))
    rawtemp:=sht.readTemperature
    term.dec(rawtemp)
    term.str(string("     degrees C = "))
    shttemp:=(rawtemp-3966)/100
    term.dec(shttemp)
    term.str(string("."))
    shttemp:=(rawtemp-3966)//100
    term.dec(shttemp)

    i++

    xG:= readGforce(x_pin)
    xg:=10*((xg-avexg)/10)
    if xg=>maxXg
      maxXg:=xG                 
    if xG=< MinXg
      MinXg:=xG    
    xGtot:=xgtot + (xG * elapsedtix)
    term.out(13)
    term.str(string(" Ave_xmG =") )
    term.dec(aveXg)
    term.str(string("   ") )
    term.out(13)
    term.str(string(" Max_mG =") )
    term.dec(MaxXg)
    term.out(13)
    term.str(string(" Min_mG =") )
    term.dec(MinXg)
    term.out(13)
    term.str(string(" Tot_mG =") )
    term.dec(XgTot)
    term.str(string("   ") )
    term.out(13)
    term.str(string(" MPH =") )
    mph:=(xgTot/1000)*22/1000 
    term.dec(MPH)
    term.str(string("  ") )
    term.out(13)
    term.str(string("Samples: "))
    term.dec(i)
    term.out(13)
    term.str(timer.showtimer)
    term.out(13)
    term.out(1)
    term.str(string("ElapsedTix= "))
    term.dec(elapsedtix)
    ii:=timer.GETTIX
    iii:=timer.getsecs
    iiii:=timer.getmins
    elapsedtix:= ii + (iii*1000) + (iiii*60000)
    elapsedtix:=elapsedtix-temptix
    ii:=timer.GETTIX
    iii:=timer.getsecs
    iiii:=timer.getmins
    temptix:= ii + (iii*1000) + (iiii*60000)

   
  timer.stop
                    

PUB readGforce(pin) | tix,g
 dira[pin]~
 waitpne(|<pin, |< pin, 0)
 waitpeq(|<pin, |< pin, 0)
 tix := cnt
 waitpne(|<pin, |< pin, 0)
 tix :=||(cnt-tix)'/(clkfreq/1_000_000)
 'tix:=tix-levelx
 tix:=(tix*10)/(clkfreq/1000000)
 tix:=tix+levelx
 g:=((tix/100)-500)*8
 return g

PUB calibratex(pin)  | tix,reps
  levelx:=0
  reps:=10
  repeat reps
    dira[pin]~
    waitpne(|<pin, |< pin, 0)
    waitpeq(|<pin, |< pin, 0)
    tix := cnt
    waitpne(|<pin, |< pin, 0)
    tix :=||(cnt-tix)
    levelx:=levelx+tix
  levelx:=levelx/reps
  levelx:= 50000-((levelx*10)/us)
  return levelx
 
 
DAT

title   byte    "Memsic Terminal Demo",13,13,0